﻿//<debug />
//<assembly>API/ISD.CAD.IO.dll</assembly>

using System;
//using System.Windows.Forms;
using System.Windows;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Controls;
//using PresentationCore;
using System.Xaml;
//using PresentationFramework;

using ISD.Scripting;
using ISD.BaseTypes;
using ISD.Math;
using ISD.CAD.Base;
using ISD.CAD.Data;
using ISD.CAD.Contexts;
using ISD.CAD.Creators;
using ISD.CAD.Modifiers;
using ISD.CAD.Views;


// Dieses Script wurde von Piet Versleijen erstellt und von Felix Gorgas weiter bearbeitet.
// Bitte seht von vervielfältigungen oder dem Posten außerhalb des CAD.de Forums ab.
// Der generelle Gedanke zur Umsetzung und die Programmierung haben viel Zeit in Anspruch
// genommen. Bitte respektiert unsere Arbeit.
// Felix Gorgas, 29.11.2016


class Script : ISD.Scripting.ScriptBase
{
    [ISD.Scripting.Context(typeof(UnconstrainedContext))]

    public static void Main()
    {

        // new Drawing with Assemblys
        //string drawingPadandName = Context.Configuration.GetProductPath("C") + "Neue Szene";
        //Scene drawing = Context.NewSceneSlot(drawingPadandName);

        // Hauptbaugruppe erstellen
        //var ac = new AssemblyCreator();
        //AssemblyNode main = Context.CreateMainAssembly(ac);
        //main.Name = "Struktur";

        // Box defintion

        //Make Window
        Window win = new Window();
        win.Title = "Auswahl";
        win.Height = 400;
        win.Width = 320;

        //Grid
        Grid myGrid = new Grid();
		//myGrid.Height = 250;
		//myGrid.Width = 250;
		//myGrid.ShowGridLines = true;
        myGrid.HorizontalAlignment = HorizontalAlignment.Left;
        myGrid.VerticalAlignment = VerticalAlignment.Center;
        //myGrid.VerticalAlignment = VerticalAlignment.Stretch;		

        // Spalten - Columns
        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //00
		myGrid.ColumnDefinitions[0].Width = new GridLength(270);
				
        myGrid.ColumnDefinitions.Add(new ColumnDefinition()); //01
		myGrid.ColumnDefinitions[1].Width = new GridLength(40);
		
        // Reihen - Rows
        myGrid.RowDefinitions.Add(new RowDefinition()); //00
		myGrid.RowDefinitions[0].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //01
		myGrid.RowDefinitions[1].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //02
		myGrid.RowDefinitions[2].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //03
		myGrid.RowDefinitions[3].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //04
		myGrid.RowDefinitions[4].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //05
		myGrid.RowDefinitions[5].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //06
		myGrid.RowDefinitions[6].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //07
		myGrid.RowDefinitions[7].Height = new GridLength(20);
	
        myGrid.RowDefinitions.Add(new RowDefinition()); //08
		myGrid.RowDefinitions[8].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //09
		myGrid.RowDefinitions[9].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //10
		myGrid.RowDefinitions[10].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //11
		myGrid.RowDefinitions[11].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //12
		myGrid.RowDefinitions[12].Height = new GridLength(20);
		
        myGrid.RowDefinitions.Add(new RowDefinition()); //13
		myGrid.RowDefinitions[13].Height = new GridLength(20);

        myGrid.RowDefinitions.Add(new RowDefinition()); //14
		myGrid.RowDefinitions[14].Height = new GridLength(30);

		myGrid.RowDefinitions.Add(new RowDefinition()); //15
		myGrid.RowDefinitions[15].Height = new GridLength(30);
		
        // Add the first text cell to the Grid
        TextBlock txt1 = new TextBlock();
        txt1.Text = " Hilfsteile";
        txt1.FontSize = 12;
        txt1.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt1, 0);
        Grid.SetColumn(txt1, 0);

        TextBlock txt2 = new TextBlock();
        txt2.Text = " ";
        txt2.FontSize = 12;
        txt2.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt2, 1);
        Grid.SetColumn(txt2, 0);

		TextBlock txt3 = new TextBlock();
        txt3.Text = " Stützen";
        txt3.FontSize = 12;
        txt3.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt3, 2);
        Grid.SetColumn(txt3, 0);
		
        TextBlock txt4 = new TextBlock();
        txt4.Text = " Binder";
        txt4.FontSize = 12;
        txt4.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt4, 3);
        Grid.SetColumn(txt4, 0);

        TextBlock txt5 = new TextBlock();
        txt5.Text = " Druck- und Koppelstäbe, Verbände";
        txt5.FontSize = 12;
        txt5.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt5, 4);
        Grid.SetColumn(txt5, 0);

        TextBlock txt6 = new TextBlock();
        txt6.Text = " Wandriegel und Tor-/Türausrahmungen";
        txt6.FontSize = 12;
        txt6.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt6, 5);
        Grid.SetColumn(txt6, 0);

        TextBlock txt7 = new TextBlock();
        txt7.Text = " Pfetten";
        txt7.FontSize = 12;
        txt7.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt7, 6);
        Grid.SetColumn(txt7, 0);

        TextBlock txt8 = new TextBlock();
        txt8.Text = " Treppen";
        txt8.FontSize = 12;
        txt8.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt8, 7);
        Grid.SetColumn(txt8, 0);

        TextBlock txt9 = new TextBlock();
        txt9.Text = " Geländer";
        txt9.FontSize = 12;
        txt9.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt9, 8);
        Grid.SetColumn(txt9, 0);

        TextBlock txt10 = new TextBlock();
        txt10.Text = " Beläge";
        txt10.FontSize = 12;
        txt10.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt10, 9);
        Grid.SetColumn(txt10, 0);

        TextBlock txt11 = new TextBlock();
        txt11.Text = " ";
        txt11.FontSize = 12;
        txt11.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt11, 10);
        Grid.SetColumn(txt11, 0);

		TextBlock txt12 = new TextBlock();
        txt12.Text = " Falls nötig: betreffendes an- & ''Alle'' abhaken.";
        txt12.FontSize = 12;
        txt12.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt12, 11);
        Grid.SetColumn(txt12, 0);

		TextBlock txt13 = new TextBlock();
        txt13.Text = " ";
        txt13.FontSize = 12;
        txt13.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt13, 12);
        Grid.SetColumn(txt13, 0);

		TextBlock txt14 = new TextBlock();
        txt14.Text = " Alle";
        txt14.FontSize = 12;
        txt14.FontWeight = FontWeights.DemiBold;
        Grid.SetRow(txt14, 13);
        Grid.SetColumn(txt14, 0);
		
        //checkboxes
        var checkbox1 = new CheckBox();
        Grid.SetRow(checkbox1, 0);
        Grid.SetColumn(checkbox1, 1);
        myGrid.Children.Add(checkbox1);

        //var checkbox2 = new CheckBox();
        //Grid.SetRow(checkbox2, 1);
        //Grid.SetColumn(checkbox2, 1);
        //myGrid.Children.Add(checkbox2);

        var checkbox3 = new CheckBox();
        Grid.SetRow(checkbox3, 2);
        Grid.SetColumn(checkbox3, 1);
        myGrid.Children.Add(checkbox3);

        var checkbox4 = new CheckBox();
        Grid.SetRow(checkbox4, 3);
        Grid.SetColumn(checkbox4, 1);
        myGrid.Children.Add(checkbox4);

        var checkbox5 = new CheckBox();
        Grid.SetRow(checkbox5, 4);
        Grid.SetColumn(checkbox5, 1);
        myGrid.Children.Add(checkbox5);

        var checkbox6 = new CheckBox();
        Grid.SetRow(checkbox6, 5);
        Grid.SetColumn(checkbox6, 1);
        myGrid.Children.Add(checkbox6);

        var checkbox7 = new CheckBox();
        Grid.SetRow(checkbox7, 6);
        Grid.SetColumn(checkbox7, 1);
        myGrid.Children.Add(checkbox7);

        var checkbox8 = new CheckBox();
        Grid.SetRow(checkbox8, 7);
        Grid.SetColumn(checkbox8, 1);
        myGrid.Children.Add(checkbox8);

        var checkbox9 = new CheckBox();
        Grid.SetRow(checkbox9, 8);
        Grid.SetColumn(checkbox9, 1);
        myGrid.Children.Add(checkbox9);

        var checkbox10 = new CheckBox();
        Grid.SetRow(checkbox10, 9);
        Grid.SetColumn(checkbox10, 1);
        myGrid.Children.Add(checkbox10);

        //var checkbox11 = new CheckBox();
        //Grid.SetRow(checkbox11, 1);
        //Grid.SetColumn(checkbox11, 1);
        //myGrid.Children.Add(checkbox11);

        //var checkbox12 = new CheckBox();
        //Grid.SetRow(checkbox12, 11);
        //Grid.SetColumn(checkbox12, 1);
        //myGrid.Children.Add(checkbox12);

        //var checkbox13 = new CheckBox();
        //Grid.SetRow(checkbox13, 12);
        //Grid.SetColumn(checkbox13, 1);
        //myGrid.Children.Add(checkbox13);

		var checkbox14 = new CheckBox();
        Grid.SetRow(checkbox14, 13);
        Grid.SetColumn(checkbox14, 1);
        myGrid.Children.Add(checkbox14);
		checkbox14.IsChecked = true; //damit ist diese Auswahlbox bereits aktiviert
		
        // Add the TextBlock elements to the Grid Children collection
        myGrid.Children.Add(txt1);
        myGrid.Children.Add(txt2);
        myGrid.Children.Add(txt3);
        myGrid.Children.Add(txt4);
        myGrid.Children.Add(txt5);
        myGrid.Children.Add(txt6);
        myGrid.Children.Add(txt7);
        myGrid.Children.Add(txt8);
        myGrid.Children.Add(txt9);
        myGrid.Children.Add(txt10);
        myGrid.Children.Add(txt11);
        myGrid.Children.Add(txt12);
        myGrid.Children.Add(txt13);
        myGrid.Children.Add(txt14);

        //Button mit Weiter
        Button btn1 = new Button();
        btn1.Content = "Weiter";
        btn1.Width = 80;
        btn1.Height = 25;
		btn1.FontSize = 12;
        Grid.SetRow(btn1, 14);
        Grid.SetColumn(btn1, 0);
        myGrid.Children.Add(btn1);
		btn1.Click += delegate (object sender, RoutedEventArgs e)
        {
            win.Close();
        };

        //Button mit Abbrechen
        Button btn2 = new Button();
        btn2.Content = "Abbrechen";
        btn2.Width = 80;
        btn2.Height = 25;
		btn2.FontSize = 12;
        Grid.SetRow(btn2, 15);
        Grid.SetColumn(btn2, 0);
        myGrid.Children.Add(btn2);
		btn2.Click += delegate (object sender, RoutedEventArgs e)
        {
			checkbox1.IsChecked = false; 		// Hilfsteile
			//checkbox2.IsChecked = false;		// Leerzeile
			checkbox3.IsChecked = false;		// Stützen
			checkbox4.IsChecked = false;		// Binder
			checkbox5.IsChecked = false;		// Druck- und Koppelstäbe
			checkbox6.IsChecked = false;		// Wandriegel
			checkbox7.IsChecked = false;		// Pfetten
			checkbox8.IsChecked = false;		// Treppen
			checkbox9.IsChecked = false;		// Geländer
			checkbox10.IsChecked = false;		// Beläge
			//checkbox11.IsChecked = false;		// Leerzeile
			//checkbox12.IsChecked = false;		// Textzeile
			//checkbox13.IsChecked = false;		// Leerzeile
			checkbox14.IsChecked = false;		// Alle
            win.Close();						// Fenster schließen
        };

		
        // Add the Grid as the Content of the Parent Window Object
        win.Content = myGrid;		
        win.ShowDialog();

        // Auswahl auswerten und die gewünschte Baugruppen erstellen
        if (Convert.ToBoolean(!checkbox14.IsChecked))
        {
            if (Convert.ToBoolean(checkbox1.IsChecked))
            {
                Part subHilfsteile = CreateSubAssembly_2("Hilfsteile");
            }

            //if (Convert.ToBoolean(checkbox2.IsChecked))
            //{
            //    Part subTragwerk = CreateSubAssembly_0("Tragwerk");
            //}
			
            if (Convert.ToBoolean(checkbox3.IsChecked))
            {
                Part subStuetzen = CreateSubAssembly_1("Stützen");
            }
			     
			if (Convert.ToBoolean(checkbox4.IsChecked))
            {
                Part subBinder = CreateSubAssembly_1("Binder");
            }
			
            if (Convert.ToBoolean(checkbox5.IsChecked))
            {
                Part subDruck = CreateSubAssembly_1("Druck- und Koppelstäbe, Verbände");
            }
			
            if (Convert.ToBoolean(checkbox6.IsChecked))
            {
                Part subWand = CreateSubAssembly_1("Wandriegel und Tor-/Türausrahmungen");
            }

            if (Convert.ToBoolean(checkbox7.IsChecked))
            {
                Part subPfetten = CreateSubAssembly_1("Pfetten");
            }

            if (Convert.ToBoolean(checkbox8.IsChecked))
            {
                Part subTreppen = CreateSubAssembly_1("Treppen");
            }

            if (Convert.ToBoolean(checkbox9.IsChecked))
            {
                Part subGeländer = CreateSubAssembly_1("Geländer");
            }

            if (Convert.ToBoolean(checkbox10.IsChecked))
            {
                Part subBeläge = CreateSubAssembly_1("Beläge");
            }
        }
        else
        {
            Part subHilfsteile = CreateSubAssembly_2("Hilfsteile");
            //Part subTragwerk = CreateSubAssembly_0("Tragwerk");
            Part subStuetzen = CreateSubAssembly_1("Stützen");
            Part subBinder = CreateSubAssembly_1("Binder");
            Part subDruck = CreateSubAssembly_1("Druck- und Koppelstäbe, Verbände");
            Part subWand = CreateSubAssembly_1("Wandriegel und Tor-/Türausrahmungen");
            Part subPfetten = CreateSubAssembly_1("Pfetten");
            Part subTreppen = CreateSubAssembly_1("Treppen");
            Part subGeländer = CreateSubAssembly_1("Geländer");
            Part subBeläge = CreateSubAssembly_1("Beläge");
        }
    }


    //Grundtyp für Überordnung => z.B. wenn Baugruppen (mit Unterbaugruppen) in eine Baugruppe gelegt werden können
    private static Part CreateSubAssembly_0(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);
		
            return null;

        }
        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try again please");
            return null;
        }
    }

    //1ter Typ Baugruppen
    private static Part CreateSubAssembly_1(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);

            // create Sub assembly 'Baugruppe' in above assembly
            AssemblyCreator sub_2 = new AssemblyCreator();
            sub_2.Name = "Baugrupe";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup2 = Context.CreateAssembly(sub_2, subgroup);

            // create Sub assembly 'Losteile' in above assembly
            AssemblyCreator sub_3 = new AssemblyCreator();
            sub_3.Name = "Losteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup3 = Context.CreateAssembly(sub_3, subgroup);

            // create Sub assembly 'Norm und Kaufteile' in above assembly
            AssemblyCreator sub_4 = new AssemblyCreator();
            sub_4.Name = "Norm und Kaufteile";
            //sub_2.Create(subgroup);
            AssemblyNode Subgroup4 = Context.CreateAssembly(sub_4, subgroup);

            return null;

        }

        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try again please");
            return null;
        }
    }

	
    //2ter Typ Baugruppen
    private static Part CreateSubAssembly_2(string subname)

    {
        try
        {
            AssemblyCreator sub = new AssemblyCreator();
            sub.Name = subname;
            AssemblyNode subgroup = Context.CreateAssembly(sub, Context.ActiveScene.MainAssembly);

            AssemblyCreator sub_2 = new AssemblyCreator();
            sub_2.Name = "Raster";
            AssemblyNode Subgroup2 = Context.CreateAssembly(sub_2, subgroup);

            AssemblyCreator sub_3 = new AssemblyCreator();
            sub_3.Name = "Skizzen";
            AssemblyNode Subgroup3 = Context.CreateAssembly(sub_3, subgroup);

            AssemblyCreator sub_4 = new AssemblyCreator();
            sub_4.Name = "Bestand";
            AssemblyNode Subgroup4 = Context.CreateAssembly(sub_4, subgroup);

		    AssemblyCreator sub_5 = new AssemblyCreator();
            sub_5.Name = "Tragwerk";
            AssemblyNode Subgroup5 = Context.CreateAssembly(sub_5, Subgroup4);

		    AssemblyCreator sub_6 = new AssemblyCreator();
            sub_6.Name = "Fassade";
            AssemblyNode Subgroup6 = Context.CreateAssembly(sub_6, Subgroup4);

		    AssemblyCreator sub_7 = new AssemblyCreator();
            sub_7.Name = "Dach";
            AssemblyNode Subgroup7 = Context.CreateAssembly(sub_7, Subgroup4);
			
            AssemblyCreator sub_8 = new AssemblyCreator();
            sub_8.Name = "Sonstiges";
            AssemblyNode Subgroup8 = Context.CreateAssembly(sub_8, subgroup);

            return null;

        }

        catch (System.Exception e)
        {
            MessageBox.Show("Assembly creation has failed, try again please");
            return null;
        }
    }

    //end of the show!!

    public static UnconstrainedContext Context
    {
        get { return BaseContext as UnconstrainedContext; }
    }



}
